package com.ningdatech.pmapi.common.constant;

import java.math.BigDecimal;

/**
 * 项目申报表单数据常量key
 * @return 
 * @author CMM
 * @since 2023/01/19 10:31 
 */
public interface ProjectDeclareConst {

    /**
     * 基本信息
     */
    class BasicInformation {
        // 项目名称
        public static final String PROJECT_NAME = "projectName";
        // 是否一地创新全省共享项目
        public static final String INNOVATION_SHARING_PROJECT = "innovationSharingProject";
        // 是否临时增补
        public static final String TEMPORARY_SUPPLEMENT = "temporarySupplement";
        // 项目负责人
        public static final String PROJECT_LEADER = "projectLeader";
        // 项目负责人手机号
        public static final String PROJECT_LEADER_PHONE_NUMBER = "projectLeaderPhoneNumber";
        // 项目联系人
        public static final String PROJECT_CONTACT = "projectContact";
        // 项目联系人手机号
        public static final String PROJECT_CONTACT_PHONE_NUMBER = "projectContactPhoneNumber";
        // 建设单位
        public static final String CONSTRUCTION_UNIT = "constructionUnit";
        // 建设单位统一信用代码
        public static final String CONSTRUCTION_UNIT_UNIFIED_CREDIT_CODE = "constructionUnitUnifiedCreditCode";
        // 项目类型
        public static final String PROJECT_TYPE = "projectType";
        // 是否首次新建
        public static final String FIRST_NEW_CONSTRUCTION = "firstNewConstruction";
        // 预算年度
        public static final String BUDGET_YEAR = "projectYear";
        // 建设开始时间
        public static final String CONSTRUCTION_START_TIME = "constructionStartTime";
        // 建设结束时间
        public static final String CONSTRUCTION_END_TIME = "constructionEndTime";
        // 四大体系
        public static final String FOUR_SYSTEM = "fourSystem";
        // 是否数字化改革项目
        public static final String  DIGITAL_REFORM_PROJECT = "digitalReformProject";
        // 建设层级
        public static final String  CONSTRUCTION_HIERARCHY = "constructionHierarchy";
        // 立项依据材料
        public static final String  PROJECT_BASIS_MATERIAL = "projectBasisMaterial";
        // 发改编码
        public static final String  CHANGE_CODE = "changeCode";
        // 财政编码
        public static final String  FISCAL_CODE = "fiscalCode";
        // 是否上云
        public static final String  ON_CLOUD = "onCloud";
        // 项目简介
        public static final String  PROJECT_INTRODUCTION = "projectIntroduction";
    }

    /**
     * 资金申报情况
     */
    class FundDeclareInfo {
        // 申报金额
        public static final String DECLARE_AMOUNT = "declareAmount";
        // 自有资金
        public static final String OWN_FUND = "ownFund";
        // 政府投资-本级财政资金
        public static final String GOVERNMENT_INVESTMENT_SAME_LEVEL_FUND = "governmentInvestmentSameLevelFund";
        // 政府投资-上级补助资金
        public static final String GOVERNMENT_INVESTMENT_SUPERIOR_FUND = "governmentInvestmentSuperiorFund";
        // 银行贷款
        public static final String BANK_LOAN = "bankLoan";
        // 其他资金
        public static final String OTHER_FUND = "otherFund";
    }

    /**
     * 总投资分配情况
     */
    class TotalInvestmentAllocations {
        // 软件开发
        public static final String SOFTWARE_DEVELOPMENT  = "softwareDevelopment";
        // 云资源、硬件配置
        public static final String CLOUD_RESOURCE_HARDWARE_CONFIGURATION  = "cloudResourceHardwareConfiguration";
        // 第三方服务
        public static final String THIRD_PARTY_SERVICE  = "thirdPartyService";
    }
    /**
     * 年度支付计划
     */
    class AnnualPaymentPlan {
        // 年度支付金额
        public static final String ANNUAL_PAYMENT_AMOUNT  = "annualPaymentAmount";
        // 自有资金
        public static final String OWN_FUND = "ownFund";
        // 政府投资-本级财政资金
        public static final String GOVERNMENT_INVESTMENT_SAME_LEVEL_FUND = "governmentInvestmentSameLevelFund";
        // 政府投资-上级补助资金
        public static final String GOVERNMENT_INVESTMENT_SUPERIOR_FUND = "governmentInvestmentSuperiorFund";
        // 银行贷款
        public static final String BANK_LOAN = "bankLoan";
        // 其他
        public static final String OTHER = "other";
    }
    /**
     * 核心业务
     */
    class CoreBusiness {

    }
    /**
     * 安全投入
     */
    class SafetyInput {
        // 投入项
        public static final String INPUT_ITEM = "inputItem";
        // 内容描述
        public static final String CONTENT_DESCRIPTION = "contentDescription";
        // 金额
        public static final String AMOUNT = "amount";
    }
    /**
     * 工程形象进度
     */
    class ProjectImageProgress {
        // 第一季度
        public static final String FIRST_QUARTER  = "firstQuarter";
        // 第二季度
        public static final String SECOND_QUARTER = "secondQuarter";
        // 第三季度
        public static final String THIRD_QUARTER = "thirdQuarter";
        // 第四季度
        public static final String FOURTH_QUARTER = "fourthQuarter";
    }
    /**
     * 附件
     */
    class Appendix {

    }
    /**
     * 备注
     */
    class Remark {

    }
    /**
     * 应用信息
     */
    class ApplicationInformation {

    }

    class Number {
        public static final BigDecimal DECLARE_AMOUNT_JUDGEMENT = BigDecimal.valueOf(1000);

        public static final Integer COUNTRY_BUILD_LEVEL = 1;
        public static final Integer PROVINCE_BUILD_LEVEL = 2;
        public static final Integer PROVINCE_SELF_BUILD_LEVEL = 3;
        public static final Integer CITY_BUILD_LEVEL = 4;
        public static final Integer CITY_SELF_BUILD_LEVEL = 5;
        public static final Integer DISTRICTS_COUNTRIES_BUILD_LEVEL = 6;
        public static final Integer VILLAGES_TOWNS_BUILD_LEVEL = 7;
    }
}
