package com.ningdatech.pmapi.expert.model.cmd;

import com.ningdatech.basic.model.PagePo;
import com.ningdatech.pmapi.expert.constant.ExpertApplyStatusEnum;
import com.ningdatech.pmapi.expert.constant.ExpertApplyTypeQueryEnum;
import com.ningdatech.pmapi.meta.model.ExpertRegionInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.util.List;

/**
 * @author liuxinxin
 * @date 2022/7/26 下午2:35
 */
@Data
@ApiModel("申请列表查询请求")
public class MetaApplyListQuery extends PagePo {

    @ApiModelProperty("审核类型")
    private List<ExpertApplyTypeQueryEnum> applyTypeList;

    @ApiModelProperty("审核结果")
    private List<ExpertApplyStatusEnum> applyStatusList;

    @ApiModelProperty("工作单位")
    private String companyName;

    @ApiModelProperty("专家姓名")
    private String expertName;

    @ApiModelProperty("职称级别字典编码")
    private String titleLevelDictionaryCode;

    @ApiModelProperty("专家层级")
    private ExpertRegionInfo expertRegion;

    @ApiModelProperty("筛选开始时间")
    private LocalDateTime applyStartTime;

    @ApiModelProperty("筛选结束时间")
    private LocalDateTime applyEndTime;

}
