package com.ningdatech.pmapi.expert.model.vo;


import com.ningdatech.pmapi.expert.model.DictionaryFieldInfo;
import com.ningdatech.pmapi.expert.model.TagFieldInfo;
import com.ningdatech.pmapi.meta.model.ExpertRegionInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * @author liuxinxin
 * @date 2022/8/4 上午11:04
 */
@Data
@ApiModel("专家库列表查询返回model")
public class ExpertAdminExpertManageListVO {

    @ApiModelProperty(value = "用户id")
    private Long userId;

    @ApiModelProperty(value = "专家姓名")
    private String expertName;

    @ApiModelProperty(value = "职称级别")
    private List<DictionaryFieldInfo> titleLevel;

    @ApiModelProperty("工作单位")
    private String company;

    @ApiModelProperty(" 单位法人编号")
    private String legalEntityCode;

    @ApiModelProperty("单位类型(字典code)")
    private List<DictionaryFieldInfo> companyAttribute;

    @ApiModelProperty(value = "手机号")
    private String phoneNo;

    @ApiModelProperty(value = "专家类型(内外围)")
    private List<DictionaryFieldInfo> expertType;

    @ApiModelProperty(value = "专家层级")
    private ExpertRegionInfo expertRegionInfo;

    @ApiModelProperty(value = "是否浙政钉用户")
    private Boolean isDingUser;

    @ApiModelProperty(value = "专家账号状态", allowableValues = "冻结：freezing,正常：normal")
    private String expertAccountStatus;

    @ApiModelProperty(value = "专家来源")
    private List<TagFieldInfo> expertSource;
}
