package com.ningdatech.pmapi.expert.model.vo;

import com.ningdatech.pmapi.expert.model.dto.ReviewTemplateOptionDTO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.experimental.Tolerate;

import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * ExpertReviewDetailVO
 * </p>
 *
 * @author WendyYang
 * @since 14:37 2023/2/15
 */
@Data
@Builder
public class ExpertReviewDetailVO {

    @Tolerate
    public ExpertReviewDetailVO() {
    }

    @ApiModelProperty("模版ID")
    private Long templateId;

    @ApiModelProperty("项目ID")
    private Long projectId;

    @ApiModelProperty("配置模版")
    private List<ReviewTemplateOptionDTO> reviewTemplateOptions;

    @ApiModelProperty("其他意见或建议")
    private String otherAdvice;

    @ApiModelProperty("附件ID")
    private Long attachFileId;

    @ApiModelProperty("评审结果：1 通过、2 需复核、3 不通过")
    private Integer reviewResult;

    @ApiModelProperty("是否是最终意见")
    private Boolean isFinal;

    @ApiModelProperty("评审时间")
    private LocalDateTime createOn;

    @ApiModelProperty("专家名称")
    private String creator;

}
