package com.ningdatech.pmapi.expert.service;

import com.ningdatech.pmapi.expert.model.entity.ExpertReview;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author WendyYang
 * @since 2023-02-15
 */
public interface IExpertReviewService extends IService<ExpertReview> {

    /**
     * 根据项目ID和专家ID获取评审记录
     *
     * @param projectId 项目ID
     * @param expertId  专家ID
     * @return 评审记录
     * @author WendyYang
     **/
    List<ExpertReview> listByProjectIdAndExpertId(Long projectId, Long expertId);

}
