package com.ningdatech.pmapi.expert.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ningdatech.pmapi.expert.entity.ExpertUserFullInfo;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author Liuxinxin
 * @since 2023-02-22
 */
public interface IExpertUserFullInfoService extends IService<ExpertUserFullInfo> {


    /**
     * 查询用户信息
     *
     * @param userId 用户ID
     * @return /
     **/
    ExpertUserFullInfo getByUserId(Long userId);

    /**
     * 查询用户信息
     *
     * @param userId 用户ID
     * @return /
     **/
    List<ExpertUserFullInfo> listByUserId(List<Long> userId);



    /**
     * 批量查询专家用户信息
     *
     * @param userIds 用户ID
     * @return /
     */
    List<ExpertUserFullInfo> listByUserIds(List<Long> userIds);

}
