package com.ningdatech.pmapi.fiscal.controller;


import com.ningdatech.pmapi.fiscal.manage.CompanyFiscalCodeManage;
import com.ningdatech.pmapi.fiscal.model.po.ReqCompanyFiscalCodeAndSealSnPO;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author Lierbao
 * @since 2023-02-10
 */
@RestController
@RequestMapping("/api/v1/fiscal-code")
@RequiredArgsConstructor
@ApiOperation("印章配置/财政编码配置")
public class CompanyFiscalCodeController {

    private final CompanyFiscalCodeManage companyFiscalCodeManage;

    @ApiOperation(value = "财政编码/配置", notes = "财政编码配置")
    @PostMapping("/fiscal-and-seal/configure")
    public void fiscalAndSealCodeConfigure(@Valid @RequestBody ReqCompanyFiscalCodeAndSealSnPO reqCompanyFiscalCodeAndSealSnPO) {
        companyFiscalCodeManage.fiscalCodeConfigure(reqCompanyFiscalCodeAndSealSnPO);
    }

}
