package com.ningdatech.pmapi.meeting.entity.domain;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 会议-实体
 * </p>
 *
 * @author WendyYang
 * @since 2022-07-26
 */
@Data
@TableName("meeting")
@ApiModel(value = "Meeting对象", description = "会议")
public class Meeting implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    @TableId(type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("事务名称")
    private String name;

    @ApiModelProperty("事务类型")
    private String type;

    @ApiModelProperty("评审耗时：1 半天、2 一天")
    private Integer meetingUsageTime;

    @ApiModelProperty("开始时间")
    private LocalDateTime startTime;

    @ApiModelProperty("结束时间")
    private LocalDateTime endTime;

    @ApiModelProperty("评委出席时间")
    private LocalDateTime judgesAttendanceTime;

    @ApiModelProperty("地区编码")
    private String regionCode;

    @ApiModelProperty("联系人")
    private String connecter;

    @ApiModelProperty("联系方式")
    private String contact;

    @ApiModelProperty("创建人")
    private String creator;

    @ApiModelProperty("会议地址")
    private String meetingAddress;

    private Integer status;

    @ApiModelProperty("抽取状态")
    private Boolean inviteStatus;

    @ApiModelProperty("是否确认名单")
    private Boolean confirmedRoster;

    @ApiModelProperty("举办单位")
    private String holdOrg;

    @ApiModelProperty("举办单位ID")
    private String holdOrgCode;

    @ApiModelProperty("是否为内部项目")
    private Boolean isInnerProject;

    @ApiModelProperty("抽取类型")
    private Integer inviteType;

    @ApiModelProperty("创建人ID")
    @TableField(fill = FieldFill.INSERT)
    private Long createBy;

    @ApiModelProperty("创建时间")
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createOn;

    @ApiModelProperty("修改人ID")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Long updateBy;

    @ApiModelProperty("修改时间")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateOn;

}
