package com.ningdatech.pmapi.meeting.entity.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * ReviewProjectDTO
 * </p>
 *
 * @author WendyYang
 * @since 10:27 2023/3/8
 */
@Data
public class ReviewProjectDTO {

    @ApiModelProperty("会议ID")
    private Long meetingId;

    @ApiModelProperty("项目ID")
    private Long projectId;

    @ApiModelProperty("项目名称")
    private String projectName;

    @ApiModelProperty("项目类型")
    private Integer projectType;

    @ApiModelProperty("预算年度")
    private Integer projectYear;

    @ApiModelProperty("申报金额")
    private BigDecimal declaredAmount;

    @ApiModelProperty("申报单位")
    private String buildOrgName;

    @ApiModelProperty("评审时间")
    private LocalDateTime reviewTime;

    @ApiModelProperty("评审类型")
    private Integer reviewType;

    @ApiModelProperty("联系人")
    private String connecter;

    @ApiModelProperty("联系方式")
    private String contact;

    @ApiModelProperty("业务领域")
    private String bizDomain;

    @ApiModelProperty("是否是专家组长")
    private Boolean isHeadman;

    @ApiModelProperty("是否已评价：0 未自评、1 已自评、2 已终评")
    private Integer reviewed;

}
