package com.ningdatech.pmapi.meeting.task;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * <p>
 * TelInviteTaskProperties
 * </p>
 *
 * @author WendyYang
 * @since 17:25 2022/9/9
 */
@Data
@Component
@ConfigurationProperties(prefix = "random-invite")
public class RandomInviteProperties {

    /**
     * 是否开启随机抽取
     */
    private Boolean enable = true;
    /**
     * 电话结果回填执行频率（分钟）
     */
    private Integer resultRewriteFixedRate = 2;
    /**
     * 随机邀请延迟执行（分钟）
     */
    private Integer inviteDelay = 2;
    /**
     * 随机邀请执行频率（分钟）
     */
    private Integer inviteFixedRate = 3;
    /**
     * 会议抽取完成通知 管理员下发会议通知
     */
    private Integer meetingInviteCompleteNoticeRate = 1;
}
