package com.ningdatech.pmapi.projectdeclared.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Classname DeclaredProjectDto
 * @Description 申报项目 里的条件判断实体
 * @Date 2023/2/1 14:52
 * @Author PoffyZhang
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ProjectConditionDTO implements Serializable {

    private Long projectId;

    @ApiModelProperty("申报金额")
    private BigDecimal declareAmount;

    @ApiModelProperty("是否临时增补 0:否 1:是")
    private Integer isTemporaryAugment;

    @ApiModelProperty("是否数字化改革项目 0:否 1:是")
    private Integer isDigitalReform;


}
