package com.ningdatech.pmapi.projectlib.model.req;

import com.ningdatech.basic.model.PagePo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * ProjectRenewalListReq
 * </p>
 *
 * @author zpf
 * @since 14:35 2023/2/15
 */
@Data
@ApiModel("项目续建资金库列表查询")
@EqualsAndHashCode(callSuper = true)
public class ProjectRenewalListReq extends PagePo {

    @ApiModelProperty("区域编码")
    private String regionCode;

    @ApiModelProperty("项目名称")
    private String projectName;

    @ApiModelProperty("项目类型")
    private Integer projectType;

    @ApiModelProperty("预算年度")
    private Integer projectYear;

    @ApiModelProperty("项目阶段")
    private Integer stage;

    @ApiModelProperty("项目状态")
    private Integer status;

    @ApiModelProperty("创建时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createOnMin;

    @ApiModelProperty("创建时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createOnMax;

    @ApiModelProperty("用户ID")
    private Long userId;

    @ApiModelProperty("单位code")
    private String orgCode;

    @ApiModelProperty("项目阶段 多个")
    private List<Integer> stageList;

    @ApiModelProperty("项目状态 多个")
    private List<Integer> statusList;
}
