package com.ningdatech.pmapi.provincial.model.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

/**
 * @Classname ProvincialProjectDTO
 * @Description
 * @Date 2023/3/2 10:06
 * @Author PoffyZhang
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(value = "ProvincialProjectDTO", description = "")
public class ProvincialProjectDTO {

    @ApiModelProperty("区域code")
    private String regionCode;

    @ApiModelProperty("区域名称")
    private String regionName;

    @ApiModelProperty("重大项目名称")
    private String projectName;

    @ApiModelProperty("重大项目code 21位")
    private String projectId;

    @ApiModelProperty("项目类型 1新建 2续建")
    private Integer projectType;

    @ApiModelProperty("项目总投资(万元)")
    private BigDecimal totalMoney;

    @ApiModelProperty("项目年度预算(万元)")
    private BigDecimal yearBudget;

    @ApiModelProperty("自有资金,政府投资-本级财政资金,政府投资-上级补助资金")
    private String budgetFrom;

    @ApiModelProperty("预算年度 2023")
    private String year;

    @ApiModelProperty("财政code 32")
    private String financialCode;

    @ApiModelProperty("发改code 23")
    private String developCode;

    @ApiModelProperty("开始时间 比如2022-11-18")
    private String beginTime;

    @ApiModelProperty("结束时间 比如2022-12-13")
    private String endTime;

    @ApiModelProperty("立项依据1111")
    private String buildBasis;

    @ApiModelProperty("立项依据材料 [{\"fileId\":\"\"}]")
    private String buildBasisFile;

    @ApiModelProperty("项目概述")
    private String projectSummary;

    @ApiModelProperty("负责人")
    private String responsibleMan;

    @ApiModelProperty("联系人联系方式")
    private String responsibleManPhone;

    @ApiModelProperty("联系人")
    private String contactName;

    @ApiModelProperty("联系人联系方式")
    private String contactPhone;

    @ApiModelProperty("建设单位 比如财政局")
    private String buildUnit;

    @ApiModelProperty("建设单位浙政钉code")
    private String buildUnitCode;

    @ApiModelProperty("主管单位")
    private String superUnit;

    @ApiModelProperty("主管单位浙政钉code")
    private String superUnitCode;

    @ApiModelProperty("可研报告文件")
    private String researchReport;

    @ApiModelProperty("项目申报书")
    private String projectApplyFile;

    @ApiModelProperty("项目总投资测算明细")
    private String projectEstimateFile;

    @ApiModelProperty("申报单位主要职责")
    private String unitThreePlan;

    @ApiModelProperty("其他附件")
    private String otherFile;

    @ApiModelProperty("项目备注111")
    private String projectRemark;

    @ApiModelProperty("是否有效 1有效  2无效  3撤回")
    private String isEffective;

    @ApiModelProperty("是否包含应用 1包含")
    private String includeApplication;

    @ApiModelProperty("app信息")
    private List<ProvincialApplicationDTO> applicationInfo;

}
