package com.ningdatech.pmapi.sms.model.po;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * @author liuxinxin
 * @date 2023/2/16 下午4:40
 */
@Data
@ApiModel(value = "VerificationCodeRequest", description = "验证码发送验证")
public class ReqVerificationCodePO implements Serializable {

    @ApiModelProperty(value = "手机号")
    @NotBlank(message = "手机号不能为空")
    private String mobile;

    @ApiModelProperty(value = "短信类型", allowableValues = "LOGIN,RECOMMENDATION_PROOF_FILE_SUBMIT")
    @NotBlank(message = "短信类型不能为空")
    private String verificationType;

}
