package com.ningdatech.pmapi.staging.model.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;

import com.ningdatech.pmapi.staging.enums.MsgTypeEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * <p>
 * 
 * </p>
 *
 * @author CMM
 * @since 2023-02-28
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@TableName("nd_work_notice_staging")
@ApiModel(value = "NdWorkNoticeStaging对象", description = "")
public class WorkNoticeStaging implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    private Long id;

    @ApiModelProperty("浙政钉用户ID")
    private Long accountId;

    @ApiModelProperty("部门编号")
    private String organizationCode;

    @ApiModelProperty("部门名称")
    private String organizationName;

    @ApiModelProperty("工作通知唯一标识")
    private String bizMsgId;

    @ApiModelProperty("接收人浙政钉ID")
    private String receiverUserId;

    @ApiModelProperty("工作通知内容")
    private String msg;

    @ApiModelProperty("重试次数 最大10次")
    private Integer retryTimes;

    @ApiModelProperty("false 可继续扫描 true 死信")
    private Boolean dead;

    @ApiModelProperty("下次扫描时间")
    private LocalDateTime nextTime;

    @ApiModelProperty("消息类型")
    private MsgTypeEnum msgType;

    @ApiModelProperty("创建时间")
    private LocalDateTime createOn;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateOn;
}
