package com.ningdatech.pmapi.todocenter.model.req;

import java.io.Serializable;
import java.time.LocalDateTime;

import com.ningdatech.basic.model.PagePo;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * 待办中心-列表查询实体信息
 *
 * @author zpf
 * @since 2023/02/19 16:01
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ToBeProcessedReq extends PagePo implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty("项目名称")
    private String projectName;

    @ApiModelProperty("申报单位名称")
    private String buildOrgName;

    @ApiModelProperty("预算年度")
    private Integer projectYear;

    @ApiModelProperty("创建时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createOnMin;

    @ApiModelProperty("创建时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createOnMax;

    @ApiModelProperty(value = "是否增补项目",allowableValues = "0,1")
    private Integer isTemporaryAugment;

    @ApiModelProperty("流程配置ID")
    private String processDefId;
}
