package com.ningdatech.pmapi.todocenter.model.vo;

import com.alibaba.excel.annotation.ExcelIgnoreUnannotated;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.wflow.workflow.bean.vo.ProcessInstanceVo;
import com.wflow.workflow.bean.vo.ProcessTaskVo;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 待办中心-待我处理返回实体信息
 *
 * @author CMM
 * @since 2023/01/12 14:57
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@ExcelIgnoreUnannotated
public class ResToBeProcessedVO implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty("项目ID")
    private Long projectId;

    @ApiModelProperty("流程实例编号")
    private String instCode;

    @ApiModelProperty("待处理节点ID")
    private String nodeId;

    @ApiModelProperty("项目名称")
    private String projectName;

    @ApiModelProperty("建设单位名称")
    private String buildOrg;

    @ApiModelProperty("建设单位统一社会信用代码")
    private String buildOrgCode;

    @ApiModelProperty("申报金额")
    private BigDecimal declaredAmount;

    @ApiModelProperty("预算年度")
    private Integer projectYear;

    @ApiModelProperty("流程状态")
    private Integer processStatus;

    @ApiModelProperty("流程状态名称")
    private String processStatusName;

    @ApiModelProperty("流程发起时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private LocalDateTime processLaunchTime;

    @ApiModelProperty("流程处理时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private LocalDateTime processHandleTime;
}
